# functions for a cgi to support the web clap.
# 2008-01 version

sub getParams {
    my $additional_char = shift;
    my %params;

# bZ[Wۑt@Cւ̃pX
    $params{mesfile_path} = './mesfile.dat';
# Ytt@CۑfBNgւ̃pX
    $params{imgdir_path} = './images/';
# Ytt@CۑĂfBNgւ̃pXiuEUł̕\pj
    $params{imgdir_path_rel} = './images/';
# pX[hiK{j
    $params{password} = '0000';
# Abv[h\ȃoCgiKBPʁj
    $params{file_size} = 1024;
# y[W^Cg
    $params{page_title} = 'webxcgi';
# cssւ̃pX
    $params{css_path} = './clapmod.css';
# s\t@C̃Abv[hF=1, =0
    $params{upload_exe} = '0';
# ېݒۑt@Cւ̃pX
    $params{denial_list_path} = './deniallist.dat';
# eݒlۑt@Cւ̃pX
    $params{config_file_path} = './config.dat';

    return $params{$additional_char};
}

sub chkPassword {
# pX[h`FbN邽߂̊֐
# 1ԂAԈĂ0Ԃ

    my $pw = shift;
    my $password = &getParams('password');

    if ($password eq $pw) {
        return 1;
    } else {
        return 0;
    }
}

sub getPaths {
# pXAzzŕԂ֐
# messages : bZ[Wt@Cւ̃pX
# images : C[WۑfBNgւ̃pX
# images_rel : C[WۑĂfBNgւ̃pXAHTMLp
# denial_list : ېݒۑt@Cւ̃pX
# config_file_path : eݒlۑt@Cւ̃pX

    my %paths = ();
    $paths{messages} = &getParams('mesfile_path');
    $paths{images} = &getParams('imgdir_path');
    $paths{images_rel} = &getParams('imgdir_path_rel');
    $paths{denial_list} = &getParams('denial_list_path');
    $paths{config_file} = &getParams('config_file_path');

    return %paths;
}

sub getConfig {
# eݒlAzzŕԂ֐
# message_max_length : ꌾbZ[Wő啶
# clap_max_number : Aő
# random_switch : 烁bZ[W̃_ݒi1Ń_j
# log_storage_life : O̕ۑ

    my $conffilepath = &getParams('config_file_path');
    my @templines;
    my @tempconfig;

    open(my $cf, $conffilepath);
    eval flock($cf, 2);
    @templines = <$cf>;
    close($cf);

    @tempconfig = split('<>', $templines[0]);

    my %config = ();
    $config{message_max_length} = $tempconfig[0];
    $config{clap_max_number} = $tempconfig[1];
    $config{random_switch} = $tempconfig[2];
    $config{log_storage_life} = $tempconfig[3];

    return %config;
}

sub getMessages {
# bZ[WzɓĕԂ֐
# Ȃ1t̃bZ[WԂA
# 'All'Ȃ炷ׂĂԂ

    my $get_param = shift;
    my %filepath = &getPaths;
    my @mesitems;
    my @messages;
    my $message = "";
    my $view = 0;

    open(my $mf, $filepath{messages});
    eval flock($mf, 2);
    @mesitems = <$mf>;
    close($mf);
    
    if ($get_param eq 'All') {
        foreach my $li (@mesitems) {
            push(@messages, $li);
        }
    } else {
        foreach my $li (@mesitems) {
            ($message, $view) = split(/<>/, $li);
            if ($view) {
                $message = &desanit($message);
                push(@messages, $message);
            }
        }
    }
    return @messages;
}

sub censorMessage {
    my $message = shift;
    my $ip = $ENV{'REMOTE_ADDR'};
    my $host = $ENV{'REMOTE_HOST'};

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "<$paths{denial_list}");
    flock ($dlf, 2);
    my @items = <$dlf>;
    foreach my $li (@items) {
        (my $disword, my $target, my $active) = split(/<>/, $li);
        if ($active) {
            my $denial_item = {'disword'=>$disword,
                               'target'=>$target};
            push(@denial_items, $denial_item);
        }
    }
    close($dlf);

    foreach my $di (@denial_items) {
        if ($di->{target} eq 'm') {
            if (index($message, $di->{disword}) >= 0) {
                return 0;
            }
        } elsif ($di->{target} eq 'i') {
            my @ips = split(/\./, $ip);
            $ip = '';
            for (my $i = 0; $i <= $#ips; $i++) {
                if (length($ips[$i]) == 3) {
                    $ip .= $ips[$i];
                } elsif (length($ips[$i]) == 2) {
                    $ip .= '0'.$ips[$i];
                } elsif (length($ips[$i]) == 1) {
                    $ip .= '00'.$ips[$i];
                }
            }
            
            (my $sip, my $eip) = split('-', $di->{disword});
            my @ips = split(/\./, $sip);
            $sip = '';
            for (my $i = 0; $i <= $#ips; $i++) {
                if (length($ips[$i]) == 3) {
                    $sip .= $ips[$i];
                } elsif (length($ips[$i]) == 2) {
                    $sip .= '0'.$ips[$i];
                } elsif (length($ips[$i]) == 1) {
                    $sip .= '00'.$ips[$i];
                }
            }

            if ($eip) {
                my @ips = split(/\./, $eip);
                $eip = '';
                for (my $i = 0; $i <= $#ips; $i++) {
                    if (length($ips[$i]) == 3) {
                        $eip .= $ips[$i];
                    } elsif (length($ips[$i]) == 2) {
                        $eip .= '0'.$ips[$i];
                    } elsif (length($ips[$i]) == 1) {
                        $eip .= '00'.$ips[$i];
                    }
                }

                if (length($eip) == 3) {
                    $eip = substr($sip, 0, length($sip) - 3).$eip;
                }

                if (length($sip) == 3) {
                    $sip .= '000000000';
                } elsif (length($sip) == 6) {
                    $sip .= '000000';
                } elsif (length($sip) == 9) {
                    $sip .= '000';
                }

                if (length($eip) == 3) {
                    $eip .= '255255255';
                } elsif (length($eip) == 6) {
                    $eip .= '255255';
                } elsif (length($eip) == 9) {
                    $eip .= '255';
                }
            } else {
                if (length($sip) == 3) {
                    $eip = $sip.'255255255';
                    $sip .= '000000000';
                } elsif (length($sip) == 6) {
                    $eip = $sip.'255255';
                    $sip .= '000000';
                } elsif (length($sip) == 9) {
                    $eip = $sip.'255';
                    $sip .= '000';
                } elsif (length($sip) == 12) {
                    $eip = $sip;
                }
            }

            if ($sip <= $ip && $ip <= $eip) {
                return 0;
            }
        } elsif ($di->{target} eq 'h') {
            if (index($host, $di->{disword}) >= 0) {
                return 0;
            }
        }
    }
    return 1;
}

sub sanit {
    my $value = shift;

    $value =~ s/&/&amp;/g;
    $value =~ s/"/&quot;/g; #"
    $value =~ s/</&lt;/g;
    $value =~ s/> /&gt;/g;
    $value =~ s/\0//g;
    $value =~ s/\r//g;
    $value =~ s/\n//g;
    return $value;
}

sub desanit {
    my $value = shift;
    
    $value =~ s/&amp;/&/g;
    $value =~ s/&quot;/"/g; #"
    $value =~ s/&lt;/</g;
    $value =~ s/&gt;/>/g;
    return $value;
}

sub codeenc {
    my $value = shift;
    my $encode = shift;
    &jcode'convert(*value, $encode, "", "z"); #'
    return $value;
}

return 1;
